#!/bin/bash

if [ -f p.ps ]
then 
  rm p.ps
fi

if [ -f epicentro.png ]
then 
  rm epicentro.png
fi

if [ -f selectas.dat ]
then 
  rm selectas.dat
fi

if [ -f run/nlloc_cr.in.1 ]
then 
  rm run/nlloc_cr.in.1
fi



#Preparar archivo con las fases en directorio obs
cp ../elocate.dat ./obs
(
cd obs
gfortran -o crear_formato2 crear_formato2.f

crear_formato2
tr '[a-z]' '[A-Z]' < fases.dat > prueba.obs
rm fases.dat elocate.dat
)
 
cut -c1-4 obs/prueba.obs > selectas.dat

#Crea formato de velocidades
awk '{if(NR>3) printf"LAYER %5.1f %5.1f 0.0 %5.1f 0.0 2.7 0.0\n",$1,$2,$3}' ../VEL.MOD > cr2.vel

cat run/modelo_base.1 > run/nlloc_cr.in.1
cat cr2.vel >> run/nlloc_cr.in.1
cat run/modelo_base.2 >> run/nlloc_cr.in.1

awk -F\; '{printf"GTSRCE %4s LATLON %9.4f %9.4f 0.0 %9.4f\n",$1,$3,$2,$5/1000}' ../estaciones2.txt > lista.est.1
if [ -f lista.est.2 ]
then
  rm lista.est.2
fi
for i in `cat selectas.dat`
do
  grep $i lista.est.1 >> lista.est.2
done

cat lista.est.2 >> run/nlloc_cr.in.1
cat run/modelo_base.3 >> run/nlloc_cr.in.1

rm lista.est.1 lista.est.2

awk -F\; '{printf"EQSTA %4s P GAU 2.1 GAU 2.1\n",$1}' ../estaciones2.txt > lista.est.3
if [ -f lista.est.4 ]
then
  rm lista.est.4
fi
for i in `cat selectas.dat`
do
  grep $i lista.est.3 >> lista.est.4
done

cat lista.est.4 >> run/nlloc_cr.in.1
rm lista.est.3 lista.est.4
cat run/modelo_base.4 >> run/nlloc_cr.in.1




echo "Corrida primera con lon=-84 lat=10.0"
ixlon=-84.0
ixlat=10.0
ixpro=0.0

sed s/"TRANS  SIMPLE  X_LAT X_LON X_DWN"/"TRANS  SIMPLE $ixlat $ixlon $ixpro"/g run/nlloc_cr.in.1 > run/nlloc_cr.in
procesar.sh

xlon=`grep GEOGRAPHIC loc/last.hyp | awk '{printf"%6.3f\n", $12}'`
xlat=`grep GEOGRAPHIC loc/last.hyp | awk '{printf"%6.3f\n", $10}'`
xpro=0.0

sed s/"TRANS  SIMPLE  X_LAT X_LON X_DWN"/"TRANS  SIMPLE $xlat $xlon $xpro"/g run/nlloc_cr.in.1 > run/nlloc_cr.in
procesar.sh

#gv gmt/centro.ps &
convert gmt/centro.ps -flatten gmt/centro.png 
display gmt/centro.png &

xlon=`grep GEOGRAPHIC loc/last.hyp | awk '{printf"%6.3f\n", $12}'`
xlat=`grep GEOGRAPHIC loc/last.hyp | awk '{printf"%6.3f\n", $10}'`
xpro=`grep GEOGRAPHIC loc/last.hyp | awk '{printf"%5.1f\n", $14}'`
xrms=`grep QUALITY loc/last.hyp | awk '{printf"%5.3f\n", $9}'`


#Correccion error en year 1920 a 2020
yy=`grep GEOGRAPHIC loc/last.hyp | awk '{print $3}'`
ya=`echo $yy | cut -c1-2 | awk '{if($1 -eq 19) print 20; else print $1}'`
yb=`echo $yy | cut -c3-4`
yy=${ya}${yb}

echo "ya= " $ya
echo "yb= " $yb
echo "yy= " $yy



mm=`grep GEOGRAPHIC loc/last.hyp | awk '{print $4}'`
dd=`grep GEOGRAPHIC loc/last.hyp | awk '{print $5}'`
hh=`grep GEOGRAPHIC loc/last.hyp | awk '{print $6}'`
nn=`grep GEOGRAPHIC loc/last.hyp | awk '{print $7}'`
ss=`grep GEOGRAPHIC loc/last.hyp | awk '{printf"%2d\n", $8}'`
etime="$yy/$mm/$dd $hh:$nn:$ss"

echo $xlon $xlat $xpro $xrms $yy $mm $dd $hh $nn $ss > resultado_nlloc.dat



echo -84.054 09.938 > sjs.dat
pf=$xpro
elon=$xlon
elat=$xlat
rms=$xrms
err_lat="---"
err_lon="---"
err_pro="---"
desanjose=`awk '{a=sqrt((x0-$1)*(x0-$1)+(y0-$2)*(y0-$2));printf"%6.1f\n", a*109.3}' x0="$elon" y0="$elat" sjs.dat`
echo $elon $elat > epi.dat




# 109.3 km corresponden a 4.1 cm que es 1 grado en este mapa
# 109.3 km corresponden a 1.61 pulgadas

#Mapa en GMT version 5.1

awk '{print $1}' loc/last.stations > lista.dat
if [ -f estaciones_usadas.dat ]
then
  rm estaciones_usadas.dat
fi
for i in `cat lista.dat`
do
    grep $i ../estaciones2.txt | awk -F\; '{print $2,$3,$1}' >> estaciones_usadas.dat     
done

 
if [ -f ../mw.dat ]
then
  cp ../mw.dat .
  mw=`head -n 1 mw.dat`
else
  mw="---"
  echo $mw > mw.dat
fi



echo "-86.6 7.815 Estaciones usadas para el c\341lculo:" > info1.dat  
echo "-86.6 7.7  Origen (UTC): " >> info1.dat
echo "-86.6 7.6  Magnitud Momento (Mw)=" >> info1.dat
echo "-86.6 7.5  Distancia de San Jos\351(km)= " >> info1.dat
echo "-86.6 7.4  Profundidad (km)= " >> info1.dat
echo "-86.6 7.3  Longitud= " >> info1.dat
echo "-86.6 7.2  Latitud= " >> info1.dat
echo "-86.6 7.1  Error RMS= " >> info1.dat

echo "-85.0 7.6 " $mw  > info2.dat
echo "-85.0 7.5 " $desanjose  >> info2.dat
echo "-85.0 7.4 " $pf "\261" $err_pro >> info2.dat
echo "-85.0 7.3 " $elon  "\261" $err_lon >> info2.dat
echo "-85.0 7.2 " $elat  "\261" $err_lat >> info2.dat
echo "-85.0 7.1 " $rms >> info2.dat

echo "-85.0 7.7 " $etime  > info3.dat





gmt gmtset MAP_FRAME_TYPE PLAIN
gmt gmtset PS_MEDIA letter

gmt psbasemap -R-86.8/-81.8/7.0/11.7 -JM8.0i -B0/0 -P  -K -X0.3i -Y3.0i -V > p.ps
#gmt grdimage ../surf.grd -R -JM -C../fondo.cpt -X0 -Y0 -I../gradients.grd -K  -O >> p.ps


gmt pscoast -R -J -N2/white -K  -Df -B -O -S150/150/150 -G100/100/100 >> p.ps
for j in /usr/local/gmt/parches/*.txt
do
  gmt psxy -R -J -O -K -B -G100/100/100 $j >> p.ps
done
gmt pscoast -R -J -N1/1.5 -W0.1 -X0 -K -Y0  -Df -B -O  -Lf-83.5/7.5/10.0/100.0+lkm >> p.ps

gmt makecpt -T-2000/5000/100 -Z -Cdem1 > n2.cpt

gmt pscoast -R -J -N1/2,black -K  -Df -B -O -W0.5 >> p.ps

awk '{print $1+0.02,$2-0.01}' estaciones_usadas.dat | gmt psxy -R -JM -W0.1 -St0.1i -G0 -O -K >> p.ps
awk '{print $1,$2}' estaciones_usadas.dat | gmt psxy -R -JM -W0.1 -St0.1i -Ggreen -O -K >> p.ps

gmt psxy -R -JM -W0.5,black -Sc0.1i -Gyellow -O -K epi.dat >> p.ps
gmt psxy -R -JM -W1.4,white -Sc0.2i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W1.2,white -Sc0.3i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W0.8,white -Sc0.4i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W0.6,white -Sc0.5i -O -K epi.dat >> p.ps
gmt psxy -R -JM -W0.2,white -Sc0.6i -O -K epi.dat >> p.ps



awk '{print $1,$2+0.25,"Epicentro"}' epi.dat | gmt pstext -R  -F+f12p,Helvetica-Bold,white+jMC -JM -O -K -TO -Gblack >> p.ps

gmt pstext -R -J -O -F+f12p,Helvetica-Bold,black,+jBR -K -W0.1 -Gwhite -TO <<END>> p.ps
-81.85 7.08 Laboratorio de Ingenier\354a S\354smica (INII-UCR)
END

gmt pstext -R -JM -O -K  -F+f12p,Helvetica-Bold,yellow,+jTR  -G0 -W0.1 -TO <<END>> p.ps
-81.84 11.65 METODO NLLOC
END


gmt psxy -R -J -W2 -Gwhite -O -K <<END>> p.ps
-86.65 7.92
-84.95 7.92
-84.95 7.05
-86.65 7.05
-86.65 7.92
END
gmt pstext -R -JM -O -K -F+f11p,Helvetica,black,+jBL info1.dat >> p.ps
gmt pstext -R -JM -O -K -F+f11p,Helvetica,black,+jBR info2.dat >> p.ps
gmt pstext -R -JM -O -K -F+f11p,Helvetica-Bold,black,+jBR info3.dat >> p.ps

gmt psxy -R -JM -W0.1 -St0.113i -Ggreen -O -K <<END>> p.ps
-85.05 7.85
END

gmt psxy -R -JM -O <<END>>p.ps
END

convert p.ps -crop 590x560+15+25 epicentro.png

display epicentro.png &









# 
# echo===========================
# echo Mapa en GMT
# echo===========================
# 
# # 109.3 km corresponden a 4.1 cm que es 1 grado en este mapa
# # 109.3 km corresponden a 1.61 pulgadas
# 
# gmtset        BASEMAP_TYPE PLAIN
# 
# echo -84.054 09.938 > sjs.dat
# psbasemap -R-86.8/-81.8/7.0/11.7 -JM8.0 -B0/0 -P  -K -X0.3 -Y3.0 -V > p.ps
# #grdimage surf.grd -R -JM -Cfondo.cpt -X0 -Y0 -Igradients.grd -K  -O >> p.ps
# 
# pscoast -R -JM -N1/5 -N2/220/220/220 -W1 -X0 -K -Y0  -Df -B -O  -Lf-83.5/7.5/10.0/100.0 -G150/150/150  -Slightblue >> p.ps
# 
# awk '{print $1}' loc/last.stations > lista.dat
# 
# if [ -f estaciones_usadas.dat ]
# then
#   rm estaciones_usadas.dat
# fi
# for i in `cat lista.dat`
# do
#     grep $i ../estaciones2.txt | awk -F\; '{print $2,$3}' | psxy -R -JM -W1 -St0.1 -Ggreen -O -K >> p.ps
#     grep $i ../estaciones2.txt | awk -F\; '{print $2,$3,$1}' >> estaciones_usadas.dat     
# done
# 
# echo "-86.6 7.815 11 0 0 1 Estaciones usadas para el c\337lculo:" > info.dat
# 
# 
# if [ -f ../mw.dat ]
# then
#   cp ../mw.dat .
#   mw=`head -n 1 mw.dat`
# else
#   mw="---"
#   echo $mw > mw.dat
# fi
# 
# pf=$xpro
# elon=$xlon
# elat=$xlat
# rms=$xrms
# err_lat="---"
# err_lon="---"
# err_pro="---"
# de=`awk '{a=sqrt((x0-$1)*(x0-$1)+(y0-$2)*(y0-$2));printf"%6.1f\n", a*109.3}' x0="$elon" y0="$elat" sjs.dat`
# 
# echo $elon $elat > epi.dat
# 
# echo "-86.6 7.7 11 0 0 1 Origen (UTC): " >> info.dat
# echo "-85.0 7.7 11 0 1 3 " $etime  >> info.dat
# 
# echo "-86.6 7.6 11 0 0 1 Magnitud Momento (Mw)=" >> info.dat
# echo "-85.0 7.6 11 0 0 3 " $mw  >> info.dat
# 
# echo "-86.6 7.5 11 0 0 1 Distancia de San Jos\345 (km)= " >> info.dat
# echo "-85.0 7.5 11 0 0 3 " $de  >> info.dat
# 
# echo "-86.6 7.4 11 0 0 1 Profundidad (km)= " >> info.dat
# echo "-85.0 7.4 11 0 0 3 " $pf "\234" $err_pro >> info.dat
# 
# echo "-86.6 7.3 11 0 0 1 Longitud= " >> info.dat
# echo "-85.0 7.3 11 0 0 3 " $elon  "\234" $err_lon >> info.dat
# 
# echo "-86.6 7.2 11 0 0 1 Latitud= " >> info.dat
# echo "-85.0 7.2 11 0 0 3 " $elat  "\234" $err_lat >> info.dat
# 
# echo "-86.6 7.1 11 0 0 1 Error RMS= " >> info.dat
# echo "-85.0 7.1 11 0 0 3 " $rms >> info.dat
# 
# 
# 
# psxy -R -JM -W1 -S+0.35 -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.1 -Gyellow -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.16 -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.22 -O -K epi.dat >> p.ps
# psxy -R -JM -W1 -Sc0.28 -O -K epi.dat >> p.ps
# awk '{print $1,$2+0.12, 10, 0, 0, 2, "Epicentro"}' epi.dat | pstext -R -JM -O -K >> p.ps
# 
# pstext -R -JM -O -K -G0 -W255/255/255O <<END>> p.ps
# -81.85 7.08 12 0 1 3 Laboratorio de Ingenier\354a S\354smica (INII-UCR)
# END
# 
# pstext -R -JM -O -K -Ggreen -W0/0/0O/255/255/255o <<END>> p.ps
# -81.83 11.58 12 0 1 3 EPICENTRO y MAGNITUD
# END
# 
# psxy -R -JM -W1 -G255 -O -K <<END>> p.ps
# -86.65 7.92
# -84.95 7.92
# -84.95 7.05
# -86.65 7.05
# -86.65 7.92
# END
# 
# 
# pstext -R -JM -O -K info.dat >> p.ps
# 
# psxy -R -JM -W1 -St0.113 -Ggreen -O -K <<END>> p.ps
# -85.05 7.85
# END
# 
# pstext -R -JM -O -K -Gred -W250/250/25O/0/0/0o <<END>> p.ps
# -86.6 8.0 14 0 1 1 M\345todo: NLLOC
# END
# 
# 
# psxy -R -JM -O <<END>>p.ps
# END
# 
# convert p.ps -crop 590x560+15+25 epicentro.png
# 
# display epicentro.png &

rm cr2.vel lista.dat sjs.dat mw.dat info.dat
rm selectas.dat 
